#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, q;
    cin >> n >> q;
    int niz[n];
    int Dk[n];
    int Pk[n];
    for (int i =0; i<n; i++){
        cin >> Dk[i] >> Pk[i];
    }
    for (int i = 0; i<q; i++){
        int H;
        cin >> H;
        bool uslov=true;
        if (Pk[i]==0){
            for(int i = 1; i<n; i++){
                H-=Dk[i-1];
                if(H<=0){
                    cout << i;
                    uslov=false;
                }

            }
            if (uslov)
                cout << -1;
        }


    }

    return 0;
}